#include <cstdio>
#include <vector>
#include <climits>
#include <algorithm>

class guard;

class node {
public:
	bool leaf;
	int cx, cy;
	node *lu, *ld, *ru, *rd;
	int lux, luy, ldx, ldy, rux, ruy, rdx, rdy;
	int xmin, ymin, xmax, ymax;
	std::vector<guard *> guards;
	
};

class guard {
public:
	int x,y;
	guard(int x, int y) { this->x = x; this->y =y;}
};

int max(int a, int b) {
	return a > b ? a : b;
}

int min(int a, int b) {
	return a < b ? a : b;
}

int abs(int a) {
	return a > 0 ? a : -a;
};

void construct(node *node) {
	if (node->guards.size() == ) {
		node->root = true;
		return;
	}
	
	
}

int main() {
	int guards, incidents;
	scanf("%d %d", &guards, &incidents);
	
	std::vector<int> guardCoordX(guards);
	std::vector<int> guardCoordY(guards);	
	
	std::vector<guard> guardX(guards);
	std::vector<guard> guardY(guards);
	
	int xmin = 5000, xmax = 0, ymin = 5000, ymax = 0;
	
	for (int i = 0; i < guards; i++) {
		scanf("%d %d", &(guardCoordX[i]), &(guardCoordY[i]));
		xmin = min(xmin, guardCoordX[i]);
		xmax = max(xmax, guardCoordX[i]);
		ymin = min(ymin, guardCoordY[i]);		
		ymax = max(ymax, guardCoordY[i]);
	}
	
	node *root = new node();
	root->cx = (xmin + xmax)/2;
	root->cy = (ymin + ymax)/2;
	
	for (int i = 0; i < guards; i++) {
		root->guards.push(new guard(guardCoordX(i), guardCoordY(i)));
	}
	
	for (int j = 0; j< incidents; j++) {
		int incX, incY;
		scanf("%d %d", &incX, &incY);
	}
	
	return 0;
}
